﻿// ==UserScript==
// @name Zvonilka_for_Opera
// @author DonpaulsSoft
// @version 1.1
// @include *
// @exclude widget://*
// ==/UserScript==

(function(window) {
	// init
	var bgColor,
		noChangeBgColor,
		fontColor,
		noChangeFontColor,
		linkType,
		convertLinks,
		convertFrom,
		convertTo,
		blackList,
		regExpSearch,
		regExpClean;
	
	// Generating complete Anchor Node
	function linkGen(telf) {
		var Link = document.createElement("a"),
			num = telf.replace(regExpClean,"");
		Link.innerText = telf;
		if(!noChangeBgColor) Link.style.backgroundColor = bgColor;
		if(!noChangeFontColor) Link.style.color = fontColor;
		Link.style.borderRadius = "3px";
		Link.href = linkType+num;
		Link.title = "Нажмите, чтобы позвонить на "+num;
		return Link;
	}
	
	// Search tagName in the tagBlacklist
	function isBlack(tag) {
		if(tag == null)
			return false;
		for(var i=0; i<blackList.length; i++)
			if(blackList[i] == tag)
				return true;
		return false;
	}
	
	// searching numbers and make links
	function searchNum(){
		var nodes = document.body.getElementsByTagName('*');
		for(var i=0; i<nodes.length;i++) {
			if(isBlack(nodes[i].tagName))
				continue;
			if(nodes[i].childNodes.length != 0) {
				for(var j=0; j<nodes[i].childNodes.length; j++) {
					if(isBlack(nodes[i].childNodes[j].tagName))
						continue;
					if(nodes[i].childNodes[j].nodeType == 3) {
						var matches = nodes[i].childNodes[j].data.match(regExpSearch);
						if(matches == null)
							continue;
						else {
							for(var k=matches.length-1; k>=0; k--) {
								var curNode = nodes[i].childNodes[j].nodeValue,
									newText = document.createTextNode(curNode.substring(curNode.lastIndexOf(matches[k])+matches[k].length, curNode.length));
								nodes[i].childNodes[j].nodeValue = curNode.substring(0, curNode.lastIndexOf(matches[k]));
								var newLink = linkGen(matches[k]);
								if(newText.nodeValue != "")nodes[i].insertBefore(newText, nodes[i].childNodes[j+1]);
								nodes[i].insertBefore(newLink, nodes[i].childNodes[j+1]);
							}
						}
					}
				}
			}
		}
	}
	
	// searching and convert links
	function convert() {
		callsites = /(della.ua)|(della.com.ua)/g;
		var url = document.location.href;
		if (callsites.test(url) == true) {
			var links = document.body.getElementsByTagName("a");
			for(var i=0; i<links.length; i++) {
				for(var j=0; j<convertFrom.length; j++)
					if(links[i].href.search(convertFrom[j]) == 0) {
						var number = links[i].href.replace(convertFrom[j],convertTo);
						links[i].href = number;
						links[i].style.backgroundColor = bgColor;
						break;
					};
			};
		};
				if (callsites2 == '') {
					var links = document.body.getElementsByTagName("a");
					for(var i=0; i<links.length; i++) {
						for(var j=0; j<convertFrom.length; j++)
							if(links[i].href.search(convertFrom[j]) == 0) {
								var number = links[i].href.replace(convertFrom[j],convertTo);
								links[i].href = number;
								links[i].style.backgroundColor = bgColor;
								break;
							};
					};
				}
				else {
					exp3 = /\w+(.)\w+/g;
					callsites2 = callsites2.match(exp3);
					var NumSites = '';
					var k = 0;
					while (callsites2[k] != undefined){
						NumSites = NumSites + '(' + callsites2[k] + ')|';
						k++;
					};
					NumSites = NumSites + '(и)';
					
					NumSites = new RegExp(NumSites, 'g');
					var url   = document.location.href;

					if (NumSites.test(url) == true) {

						var links = document.body.getElementsByTagName("a");
						for(var i=0; i<links.length; i++) {
							for(var j=0; j<convertFrom.length; j++)
								if(links[i].href.search(convertFrom[j]) == 0) {
									var number = links[i].href.replace(convertFrom[j],	convertTo);
									links[i].href = number;
									links[i].style.backgroundColor = bgColor;
									break;
								};
						};
					};
				};
	};
	
	//main
	function ready() {
		if(convertLinks) convert();
		console.time("process");
		searchNum();
		console.timeEnd("process");
	}
	
	// wait for inbox data and start
	opera.extension.addEventListener("message", function(event) {
		var data = event.data;
		
		bgColor = data.bgColor,
		noChangeBgColor = data.noChangeBgColor,
		fontColor = data.fontColor,
		noChangeFontColor = data.noChangeFontColor,
		linkType = "telf:", convertWhere = data.linkType,
		convertLinks = data.convertLinks,
		convertFrom = data.convertFrom.split(" "),
		callsites2 = data.linkType,
		convertTo = "telf:",
		blackList = data.blackList.split(" "),
		regExpSearch = new RegExp(data.regExpSearch,"g"),
		regExpClean = new RegExp(data.regExpClean,"g");
		document.addEventListener("DOMContentLoaded", ready, false);
	}, false);
})(window);
