﻿window.addEventListener("load", main, false);

function main(){
	var prefs = widget.preferences,
		options = document.querySelectorAll("*[name]");
	
	// get current settings
	for (var i = 0; i < options.length; i++) {
		if (typeof prefs[options[i].name] !== "undefined") {
			if(options[i].type == "checkbox")
				options[i].checked = Boolean(prefs.getItem(options[i].name)); // for input type=checkbox
			else
				options[i].value = prefs.getItem(options[i].name);  // for others input types
		}
	}
	
	// set the listeners for the in-time saving
	for (var i = 0; i < options.length; i++) {
		(function(i) {
			options[i].addEventListener('change', function(e){
				if (e.srcElement.type == "checkbox")
					if(e.srcElement.checked == true)
						prefs.setItem(e.srcElement.name, e.srcElement.checked);
					else
						prefs.setItem(e.srcElement.name, ""); // for get correct "false" using Boolean("")
				else {
					if(e.srcElement.name == "blackList") {
						var data = e.srcElement.value.replace(/[\s ,;]+/g, " ").toUpperCase();
						prefs.setItem(e.srcElement.name, data);
					}
					else 
						if(e.srcElement.name == "convertFrom") {
							var data = e.srcElement.value.replace(/[\s ,;]+/g, " ");
							prefs.setItem(e.srcElement.name, data);
						}
						else
							prefs.setItem(e.srcElement.name, e.srcElement.value); // others input types
				}
			}, false);
		})(i);
	}
	
	// Make input type=color more interactive
	var ranges = document.querySelectorAll("input[type='color']");
	for (var i = 0; i < ranges.length; i++) {
		if (typeof prefs[ranges[i].name] !== "undefined") // get current set
			ranges[i].parentElement.getElementsByTagName("div")[0].innerHTML = ranges[i].value;
		(function(i) { //----------------------------------> set the listeners for ranges
			ranges[i].addEventListener('change', function(e){
				e.srcElement.parentElement.getElementsByTagName("div")[0].innerHTML = e.srcElement.value;
			}, false);
		})(i);
	}
	
	// spoiler
	var extendDiv = document.getElementById("extendDiv"),
		extendButton = document.getElementById("extendButton");
	extendButton.addEventListener("click", function(){
		extendDiv.style.display = (extendDiv.style.display == "block") ? "none" : "block";
		extendButton.value = (extendButton.value === "Открыть расширенные") ? "Скрыть расширенные" : "Открыть расширенные";
	}, false);
	
	// reset to defaults
	var resetButton = document.getElementById("resetButton");
	resetButton.addEventListener("click", function(){
		setDefaultOptions(true);
		window.location.reload();
	}, false);
	
	// block some fields
	var noChangeBg = document.getElementsByName("noChangeBgColor")[0],
		noChangeFont = document.getElementsByName("noChangeFontColor")[0],
		convLinks = document.getElementsByName("convertLinks")[0],
		
		bgColor = document.getElementsByName("bgColor")[0],
		fontColor = document.getElementsByName("fontColor")[0],
		convertFrom = document.getElementsByName("convertFrom")[0],
		convertTo = document.getElementsByName("convertTo")[0];
	
	function disable(elem) {
		elem.disabled = true;
		elem.style.opacity = 0.3;
	}
	function enable(elem) {
		elem.disabled = false;
		elem.style.opacity = 1;
	}
	
	if(noChangeBg.checked) disable(bgColor);
	if(noChangeFont.checked) disable(fontColor);
	if(!convLinks.checked) {
		disable(convertFrom);
		disable(convertTo);
	}
	
	noChangeBg.addEventListener('change', function(e){
		if(e.srcElement.checked == true)
			disable(bgColor);
		else
			enable(bgColor);
	}, false);
	noChangeFont.addEventListener('change', function(e){
		if(e.srcElement.checked == true)
			disable(fontColor);
		else
			enable(fontColor);
	}, false);
	convLinks.addEventListener('change', function(e){
		if(e.srcElement.checked == false) {
			disable(convertFrom);
			disable(convertTo);
		}
		else {
			enable(convertFrom);
			enable(convertTo);
		}
	}, false);
}
